Index: ruby/trunk/lib/adl_parser/lib/adl_scanner.rb
===================================================================
--- ruby/trunk/lib/adl_parser/lib/adl_scanner.rb	(revision 268)
+++ ruby/trunk/lib/adl_parser/lib/adl_scanner.rb	(revision 283)
@@ -730,4 +194,5 @@
                 yield :V_GENERIC_TYPE_IDENTIFIER, $&
               when /\A[0-9]+|[0-9]+[eE][+-]?[0-9]+/   #V_INTEGER
+                @@logger.debug("ADLScanner#scan: V_INTEGER = #{$&}")
                 yield :V_INTEGER, $&
               when /\A[0-9]+\.[0-9]+|[0-9]+\.[0-9]+[eE][+-]?[0-9]+ /   #V_REAL
@@ -742,4 +207,24 @@
               end
               data = $' # variable $' receives the string after the match
+            when :dadl
+              dadl_scanner = OpenEHR::ADL::Scanner::DADLScanner.new(@adl_type, @filename, @lineno)
+              data = dadl_scanner.scan(data) do |sym, val|
+                yield sym, val
+              end
+            when :cadl
+              cadl_scanner = OpenEHR::ADL::Scanner::CADLScanner.new(@adl_type, @filename, @lineno)
+              data = cadl_scanner.scan(data) do |sym, val|
+                yield sym, val
+              end
+            when :regexp
+              regex_scanner = OpenEHR::ADL::Scanner::RegexScanner.new(@adl_type, @filename, @lineno)
+              data = regex_scanner.scan(data) do |sym, val|
+                yield sym, val
+              end
+            when :term_constraint
+              term_constraint_scanner = OpenEHR::ADL::Scanner::TermConstraintScanner.new(@adl_type, @filename, @lineno)
+              data = term_constraint_scanner.scan(data) do |sym, val|
+                yield sym, val
+              end
             else
               raise
@@ -747,137 +232,11 @@
           end
         end
-      end
-
-
-      module Common
-        class START_TERM_CODE_CONSTRAINT
-          include Yaparc::Parsable
-          def initialize
-            @parser = lambda do |input|
-              Yaparc::Apply.new(Yaparc::Regex.new(/[ \t\n]*\[([a-zA-Z0-9\(\)\._\-]+)::[ \t\n]*/)) do |match|
-                OpenEHR::LOG.info("START_TERM_CODE_CONSTRAINT: #{match}")
-                [:START_TERM_CODE_CONSTRAINT, match]
-              end
-            end
-          end
-        end
-
-        # /\A\[[a-zA-Z0-9()\._-]+::[a-zA-Z0-9\._-]+\]/  #V_QUALIFIED_TERM_CODE_REF form [ICD10AM(1998)::F23]
-        class V_QUALIFIED_TERM_CODE_REF
-          include Yaparc::Parsable
-          def initialize
-            @parser = lambda do |input|
-              Yaparc::Apply.new(Yaparc::Regex.new(/\A\[[a-zA-Z0-9()\._-]+::[a-zA-Z0-9\._-]+\]/)) do |match|
-                OpenEHR::LOG.info("V_QUALIFIED_TERM_CODE_REF: #{match}")
-                [:V_QUALIFIED_TERM_CODE_REF, match]
-              end
-            end
-          end
-        end
-        
-        class V_LOCAL_TERM_CODE_REF
-          include Yaparc::Parsable
-          def initialize
-            @parser = lambda do |input|
-              Yaparc::Apply.new(Yaparc::Regex.new(/\A\[[a-zA-Z0-9][a-zA-Z0-9._\-]*\]/)) do |match|
-                OpenEHR::LOG.info("V_TERM_CODE_REF: #{match}")
-                [:V_LOCAL_TERM_CODE_REF, match]
-              end
-            end
-          end
-        end
-
-        class ERR_V_QUALIFIED_TERM_CODE_REF
-          include Yaparc::Parsable
-          def initialize
-            @parser = lambda do |input|
-              Yaparc::Apply.new(Yaparc::Regex.new(/\A\[[a-zA-Z0-9._\- ]+::[a-zA-Z0-9._\- ]+\]/)) do |match|
-                OpenEHR::LOG.info("ERR_V_QUALIFIED_TERM_CODE_REF: #{match}")
-                [:ERR_V_QUALIFIED_TERM_CODE_REF, match]
-              end
-            end
-          end
-        end
-
-        class V_TYPE_IDENTIFIER
-          include Yaparc::Parsable
-          def initialize
-            @parser = lambda do |input|
-              Yaparc::Apply.new(Yaparc::Regex.new(/\A[A-Z][a-zA-Z0-9_]*/)) do |match|
-                OpenEHR::LOG.info("V_TYPE_IDENTIFIER: #{match}")
-                [:V_TYPE_IDENTIFIER, match]
-              end
-            end
-          end
-        end
-
-        class V_GENERIC_TYPE_IDENTIFIER
-          include Yaparc::Parsable
-          def initialize
-            @parser = lambda do |input|
-              Yaparc::Apply.new(Yaparc::Regex.new(/\A[A-Z][a-zA-Z0-9_]*<[a-zA-Z0-9,_<>]+>/)) do |match|
-                OpenEHR::LOG.info("V_GENERIC_TYPE_IDENTIFIER: #{match}")
-                [:V_GENERIC_TYPE_IDENTIFIER, match]
-              end
-            end
-          end
-        end
-
-
-        class V_LOCAL_CODE
-          include Yaparc::Parsable
-          def initialize
-            @parser = lambda do |input|
-              Yaparc::Apply.new(Yaparc::Regex.new(/\Aa[ct][0-9.]+/)) do |match|
-                OpenEHR::LOG.info("V_LOCAL_CODE: #{match}")
-                [:V_LOCAL_CODE, match]
-              end
-            end
-          end
-        end
-
-        class V_STRING
-          include Yaparc::Parsable
-          def initialize
-            @parser = lambda do |input|
-              Yaparc::Apply.new(Yaparc::Regex.new(/\A"([^"]*)"/m)) do |match|
-                OpenEHR::LOG.info("V_STRING: #{match}")
-                [:V_STRING, match]
-              end
-            end
-          end
-        end
-
-        class V_REAL
-          include Yaparc::Parsable
-          def initialize
-            @parser = lambda do |input|
-              Yaparc::Apply.new(Yaparc::Regex.new(/\A[0-9]+\.[0-9]+|[0-9]+\.[0-9]+[eE][+-]?[0-9]+/)) do |match|
-                OpenEHR::LOG.info("V_REAL: #{match}")
-                [:V_REAL, match]
-              end
-            end
-          end
-        end
-
-        #V_ISO8601_DURATION PnYnMnWnDTnnHnnMnnS
-        class V_ISO8601_DURATION
-          include Yaparc::Parsable
-          def initialize
-            @parser = lambda do |input|
-              Yaparc::Apply.new(
-                                Yaparc::Alt.new(Yaparc::Regex.new(/\AP([0-9]+|[yY])?([0-9]+|[mM])?([0-9]+|[wW])?([0-9]+|[dD])?T([0-9]+|[hH])?([0-9]+|[mM])?([0-9]+|[sS])?/),
-                                                Yaparc::Regex.new(/\AP([0-9]+|[yY])?([0-9]+|[mM])?([0-9]+|[wW])?([0-9]+|[dD])?/))) do |match|
-                OpenEHR::LOG.info("V_ISO8601_DURATION: #{match}")
-                [:V_ISO8601_DURATION, match]
-              end
-            end
-          end
-        end
-
-      end # of Common
-
-      module DADL
-        # c.f. http://www.openehr.org/svn/ref_impl_eiffel/TRUNK/components/adl_parser/src/syntax/adl/parser/adl_scanner.l
+      end # of ADLScanner
+
+      #
+      # DADLScanner
+      # 
+      class DADLScanner < Base
+        @@logger = OpenEHR::ADL::Scanner::LOGGER #Logger.new('log/scanner.log')
         RESERVED = {
           'true' => :SYM_TRUE, #[Tt][Rr][Uu][Ee] -- -> SYM_TRUE 
@@ -885,56 +244,185 @@
           'infinity' => :SYM_INFINITY # [Ii][Nn][Ff][Ii][Nn][Ii][Tt][Yy] -- -> SYM_INFINITY 
         }
+
+        def initialize(adl_type, filename, lineno = 1)
+          super(adl_type, filename, lineno)
+          @in_interval = false
+          @in_c_domain_type = false
+        end
+
         #
-        # DADL::RootScanner
+        # DADLScanner#scan
         #
-        class RootScanner
-          include Yaparc::Parsable
-          def initialize
-            @parser = lambda do |input|
-              Yaparc::Alt.new(Reserved.new,
-                              OpenEHR::ADL::Scanner::Common::V_QUALIFIED_TERM_CODE_REF.new,
-                              OpenEHR::ADL::Scanner::Common::V_LOCAL_TERM_CODE_REF.new,
-                              OpenEHR::ADL::Scanner::Common::ERR_V_QUALIFIED_TERM_CODE_REF.new,
-                              OpenEHR::ADL::Scanner::Common::V_TYPE_IDENTIFIER.new,
-                              OpenEHR::ADL::Scanner::Common::V_GENERIC_TYPE_IDENTIFIER.new,
-                              OpenEHR::ADL::Scanner::Common::V_STRING.new,
-                              OpenEHR::ADL::Scanner::Common::V_LOCAL_CODE.new,
-                              OpenEHR::ADL::Scanner::Common::V_REAL.new,
-                              OpenEHR::ADL::Scanner::Common::V_ISO8601_DURATION.new#,
-                              #OpenEHR::ADL::Scanner::Common::START_TERM_CODE_CONSTRAINT.new
-                              )
+        def scan(data)
+          @@logger.debug("Entering DADLScanner#scan at #{@filename}:#{@lineno}: @adl_type = #{@adl_type.inspect}, data = #{data.inspect}")
+          until data.nil?  do
+            @@logger.debug("#{@filename}:#{@lineno}: DADLScanner#scan:loop data = #{data.inspect}")
+            case @adl_type.last
+            when :dadl
+              case data
+              when /\A\n/ # carriage return
+                #@@logger.debug("DADLScanner#scan:  carriage return, data = #{data.inspect}")
+                @lineno += 1
+                ;
+              when /\A[ \t\r\f]+/ #just drop it
+                #@@logger.debug("DADLScanner#scan:  white space, data = #{data.inspect}")
+                ;
+              when /\A--.*/ # single line comment
+#                @lineno += 1
+                @@logger.debug("DADLScanner#scan: COMMENT = #{$&} at #{@filename}:#{@lineno}")
+                ;
+              when /\A[a-z][a-zA-Z0-9_]*/
+                word = $&.dup
+                if RESERVED[word.downcase]
+                  yield RESERVED[word.downcase], RESERVED[word.downcase]
+                else
+                  @@logger.debug("DADLScanner#scan: V_ATTRIBUTE_IDENTIFIER = #{word} at #{@filename}:#{@lineno}")
+                  yield :V_ATTRIBUTE_IDENTIFIER, word #V_ATTRIBUTE_IDENTIFIER /\A[a-z][a-zA-Z0-9_]*/
+                end
+                ###----------/* symbols */ ------------------------------------------------- 
+              when /\A\=/   # =
+                yield :SYM_EQ, :SYM_EQ
+              when /\A\>\=/   # >=
+                yield :SYM_GE, :SYM_GE
+              when /\A\<\=/   # <=
+                yield :SYM_LE, :SYM_LE
+              when /\A\</   # <
+                if @in_interval
+                  yield :SYM_LT, :SYM_LT
+                else
+                  @adl_type.push(:dadl)
+                  yield :SYM_START_DBLOCK, :SYM_START_DBLOCK
+                end
+              when /\A\>/   # >
+                if @in_interval
+                  yield :SYM_GT, :SYM_GT
+                elsif @in_c_domain_type == true
+                  assert_at(__FILE__,__LINE__){@adl_type.last == :dadl}
+                  adl_type = @adl_type.pop
+                  if @adl_type.last == :cadl
+                    @in_c_domain_type = false
+                    yield :END_V_C_DOMAIN_TYPE_BLOCK, $&
+                  else
+                    yield :SYM_END_DBLOCK, $&
+                  end
+                elsif @in_c_domain_type == false
+                  adl_type = @adl_type.pop
+                  assert_at(__FILE__,__LINE__){adl_type == :dadl}
+                  yield :SYM_END_DBLOCK, $&
+                else
+                  raise
+                end
+              when /\A\-/   # -
+                yield :Minus_code, :Minus_code
+              when /\A\+/   # +
+                yield :Plus_code, :Plus_code
+              when /\A\*/   # *
+                yield :Star_code, :Star_code
+              when /\A\//   # /
+                yield :Slash_code, :Slash_code
+              when /\A\^/   # ^
+                yield :Caret_code, :Caret_code
+              when /\A\.\.\./   # ...
+                yield :SYM_LIST_CONTINUE, :SYM_LIST_CONTINUE
+              when /\A\.\./   # ..
+                yield :SYM_ELLIPSIS, :SYM_ELLIPSIS
+              when /\A\./   # .
+                yield :Dot_code, :Dot_code
+              when /\A\;/   # ;
+                yield :Semicolon_code, :Semicolon_code
+              when /\A\,/   # ,
+                yield :Comma_code, :Comma_code
+              when /\A\:/   # :
+                yield :Colon_code, :Colon_code
+              when /\A\!/   # !
+                yield :Exclamation_code, :Exclamation_code
+              when /\A\(/   # (
+                yield :Left_parenthesis_code, :Left_parenthesis_code
+              when /\A\)/   # )
+                yield :Right_parenthesis_code, :Right_parenthesis_code
+              when /\A\$/   # $
+                yield :Dollar_code, :Dollar_code
+              when /\A\?\?/   # ??
+                yield :SYM_DT_UNKNOWN, :SYM_DT_UNKNOWN
+              when /\A\?/   # ?
+                yield :Question_mark_code, :Question_mark_code
+              when /\A\|/   # |
+                @@logger.debug("DADLScanner#scan: @in_interval = #{@in_interval} at #{@filename}:#{@lineno}")
+                if @in_interval
+                  @in_interval = false
+                else
+                  #          @in_interval = false
+                  @in_interval = true
+                end
+                @@logger.debug("DADLScanner#scan: SYM_INTERVAL_DELIM at #{@filename}:#{@lineno}")
+                yield :SYM_INTERVAL_DELIM, :SYM_INTERVAL_DELIM
+              when /\A\[([a-zA-Z0-9()\._-]+::[a-zA-Z0-9\._-]+)\]/  #V_QUALIFIED_TERM_CODE_REF form [ICD10AM(1998)::F23]
+                yield :V_QUALIFIED_TERM_CODE_REF, $1
+              when /\A\[/   # [
+                @@logger.debug("DADLScanner#scan: Left_bracket_code at #{@filename}:#{@lineno}")
+                yield :Left_bracket_code, :Left_bracket_code
+              when /\A\]/   # ]
+                @@logger.debug("DADLScanner#scan: Right_bracket_code at #{@filename}:#{@lineno}")
+                yield :Right_bracket_code, :Right_bracket_code
+              when /\A[0-9]{4}-[0-1][0-9]-[0-3][0-9]T[0-2][0-9]:[0-6][0-9]:[0-6][0-9](,[0-9]+)?(Z|[+-][0-9]{4})?|[0-9]{4}-[0-1][0-9]-[0-3][0-9]T[0-2][0-9]:[0-6][0-9](Z|[+-][0-9]{4})?|[0-9]{4}-[0-1][0-9]-[0-3][0-9]T[0-2][0-9](Z|[+-][0-9]{4})?/   #V_ISO8601_EXTENDED_DATE_TIME YYYY-MM-DDThh:mm:ss[,sss][Z|+/- -n-n-n-n-]-
+                @@logger.debug("DADLScanner#scan: V_ISO8601_EXTENDED_DATE_TIME")
+                yield :V_ISO8601_EXTENDED_DATE_TIME, $&
+              when /\A[0-2][0-9]:[0-6][0-9]:[0-6][0-9](,[0-9]+)?(Z|[+-][0-9]{4})?|[0-2][0-9]:[0-6][0-9](Z|[+-][0-9]{4})? /   #V_ISO8601_EXTENDED_TIME hh:mm:ss[,sss][Z|+/-nnnn]
+                @@logger.debug("DADLScanner#scan: V_ISO8601_EXTENDED_TIME")
+                yield :V_ISO8601_EXTENDED_TIME, $&
+              when /\A\d{4}-[0-1][0-9]-[0-3][0-9]|[0-9]{4}-[0-1][0-9]/   #V_ISO8601_EXTENDED_DATE YYYY-MM-DD
+                @@logger.debug("DADLScanner#scan: V_ISO8601_EXTENDED_DATE, #{$&}")
+                yield :V_ISO8601_EXTENDED_DATE, $&
+              when /\A[A-Z][a-zA-Z0-9_]*<[a-zA-Z0-9,_<>]+>/   #V_GENERIC_TYPE_IDENTIFIER
+                yield :V_GENERIC_TYPE_IDENTIFIER, $&
+              when /\A"((?:[^"\\]+|\\.)*)"/ #V_STRING
+                @@logger.debug("DADLScanner#scan: V_STRING, #{$1}")
+                yield :V_STRING, $1
+              when /\A"([^"]*)"/m #V_STRING
+                @@logger.debug("DADLScanner#scan: V_STRING, #{$1}")
+                yield :V_STRING, $1
+              when /\A[0-9]+|[0-9]+[eE][+-]?[0-9]+/   #V_INTEGER
+                @@logger.debug("DADLScanner#scan: V_INTEGER = #{$&}")
+                yield :V_INTEGER, $&
+              when /\A[a-z]+:\/\/[^<>|\\{}^~"\[\] ]*/ #V_URI
+                yield :V_URI, $&
+              when /\A\S/ #UTF8CHAR
+                yield :UTF8CHAR, $&
+              end
+              data = $' # variable $' receives the string after the match
+            when :adl
+              adl_scanner = OpenEHR::ADL::Scanner::ADLScanner.new(@adl_type, @filename, @lineno)
+              data = adl_scanner.scan(data) do |sym, val|
+                yield sym, val
+              end
+            when :cadl
+              cadl_scanner = OpenEHR::ADL::Scanner::CADLScanner.new(@adl_type, @filename, @lineno)
+              data = cadl_scanner.scan(data) do |sym, val|
+                yield sym, val
+              end
+            when :regexp
+              regex_scanner = OpenEHR::ADL::Scanner::RegexScanner.new(@adl_type, @filename, @lineno)
+              data = regex_scanner.scan(data) do |sym, val|
+                yield sym, val
+              end
+            when :term_constraint
+              @@logger.debug("#{__FILE__}:#{__LINE__}: scan_dadl: Entering scan_term_constraint at #{@filename}:#{@lineno}: data = #{data.inspect}")
+              term_constraint_scanner = OpenEHR::ADL::Scanner::TermConstraintScanner.new(@adl_type, @filename, @lineno)
+              data = term_constraint_scanner.scan(data) do |sym, val|
+                yield sym, val
+              end
+            else
+              raise
             end
           end
         end
-
-        #  <DADL::Reserved class>
-        class Reserved
-          include Yaparc::Parsable
-          
-          def initialize
-            @parser = lambda do |input|
-              reserved_parsers = OpenEHR::ADL::Scanner::DADL::RESERVED.map do |keyword| 
-                Yaparc::Tokenize.new(
-                                     Yaparc::Literal.new(keyword[0],false)
-                                     )
-              end
-              Yaparc::Alt.new(Yaparc::Apply.new(Yaparc::Alt.new(*reserved_parsers)) do |match|
-                                OpenEHR::LOG.info("Reserved: #{match}")
-                                [OpenEHR::ADL::Scanner::DADL::RESERVED[match], OpenEHR::ADL::Scanner::DADL::RESERVED[match]]
-                              end,
-                              Yaparc::Apply.new(Yaparc::Regex.new(/\A[a-z][a-zA-Z0-9_]*/)) do |match|
-                                OpenEHR::LOG.info("V_ATTRIBUTE_IDENTIFIER: #{match}")
-                                [:V_ATTRIBUTE_IDENTIFIER, match]
-                              end)
-            end
-          end
-        end
-      end # of DADL
-
-      module CADL
-        # c.f. http://www.openehr.org/svn/ref_impl_eiffel/TRUNK/components/adl_parser/src/syntax/cadl/parser/cadl_scanner.l
+      end # of DADLScanner
+
+
+
+      class CADLScanner < Base
+
+        @@logger = OpenEHR::ADL::Scanner::LOGGER #Logger.new('log/scanner.log')        #Logger.new('log/scanner.log')
         RESERVED = {
-          'ordered' => :SYM_ORDERED, # [Oo][Rr][Dd][Ee][Rr][Ee][Dd]
-          'unordered' => :SYM_UNORDERED, # [Uu][Nn][Oo][Rr][Dd][Ee][Rr][Ee][Dd]
           'then' => :SYM_THEN, # [Tt][Hh][Ee][Nn]
           'else' => :SYM_ELSE, # [Ee][Ll][Ss][Ee]
@@ -951,4 +439,6 @@
           'occurrences' => :SYM_OCCURRENCES, # [Oo][Cc][Cc][Uu][Rr][Rr][Ee][Nn][Cc][Ee][Ss]
           'cardinality' => :SYM_CARDINALITY, # [Cc][Aa][Rr][Dd][Ii][Nn][Aa][Ll][Ii][Tt][Yy]
+          'ordered' => :SYM_ORDERED, # [Oo][Rr][Dd][Ee][Rr][Ee][Dd]
+          'unordered' => :SYM_UNORDERED, # [Uu][Nn][Oo][Rr][Dd][Ee][Rr][Ee][Dd]
           'unique' => :SYM_UNIQUE, # [Uu][Nn][Ii][Qq][Uu][Ee]
           'matches' => :SYM_MATCHES, # [Mm][Aa][Tt][Cc][Hh][Ee][Ss]
